catalog/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.index, name = 'index'),
    path('books/', views.BookListView.as_view(), name = 'books'),
    path('book/<int:pk>', views.BookDetailView.as_view(), name = 'book-detail'),
    path('mybooks/', views.LoanedBooksByUserListView.as_view(), name='my-borrowed'),
    path('book/<uuid:pk>/renew/', views.renew_book_librarian, name='renew-book-librarian'),
]

locallibrary/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic import RedirectView
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('catalog/', include('catalog.urls')),
    path('', RedirectView.as_view(url='/catalog/', permanent=True)),
    path('accounts/', include('django.contrib.auth.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

catalog/models.py
from django.db import models
from django.urls import reverse
from django.contrib.auth.models import User
from datetime import date


class Genre(models.Model):
    """
    Model representing book genre
    """

    name = models.CharField(max_length=200, help_text='Enter a book genre \
                            (e.g. Thriller)'
                            )

    def __str__(self):
        """
        String representation pf the Model object
        :return: name
        """
        return self.name

class Book(models.Model):
    """
    Model representing a book
    """
    title = models.CharField(max_length=200)
    author = models.ForeignKey('Author', on_delete=models.SET_NULL, null=True)
    summary = models.TextField(max_length=1000, help_text='Enter a brief summary of the book'),
    isbn = models.CharField('ISBN', max_length=13, help_text='13 character ISBN Number')
    genre = models.ManyToManyField(Genre, help_text='Select a Genre for this book')
    language = models.ForeignKey('Language', help_text='Select the language of the book', on_delete=models.SET_NULL, null=True)

    def __str__(self):
        """
         String representation of the Model object
        :return: title
        """
        return self.title
    def display_genre(self):
        """
        Create a string for the genre
        :return:
        """
        return ', '.join(genre.name for genre in self.genre.all()[:3])

    display_genre.short_description = 'Genre'

    def get_absolute_url(self):
        """
        Returns the url to access the details record of the book
        :return:
        """
        return reverse('book-detail', args=[str(self.id)])


import uuid

class BookInstance(models.Model):

    """
    Model representing a specific copy of a book
    """
    id = models.UUIDField(primary_key=True, default=uuid.uuid4, help_text='Unique ID for this book')
    book = models.ForeignKey('Book', on_delete=models.SET_NULL, null=True)
    imprint = models.CharField(max_length = 200)
    due_back = models.DateField(null=True, blank = True, help_text = "Due date of returning the book")
    LOAN_STATUS = (
        ('m', 'Maintenance'),
        ('o', 'On Loan'),
        ('a', 'Available'),
        ('r', 'Reserved'),
    )
    status = models.CharField(max_length=1, choices=LOAN_STATUS, blank=True, default='m',
                              help_text='Book Availability')
    borrower = models.ForeignKey(User, on_delete=models.SET_NULL, null=True, blank=True)

    class Meta:
        ordering = ['due_back']
        permissions = (("can_mark_returned", "Set book as returned"),)

    def __str__(self):
        return f'{self.id} ({self.book.title})'

    @property
    def is_overdue(self):
        if self.due_back and date.today() > self.due_back:
            return True
        return False

class Author(models.Model):
    """
    Model representing Author
    """
    first_name = models.CharField(max_length=100)
    last_name = models.CharField(max_length=100)
    date_of_birth = models.DateField(null = True, blank= True)
    date_of_death = models.DateField('Died', null = True, blank= True)

    class Meta:
        ordering = ['last_name', 'first_name']

    def __str__(self):
        return f'{self.last_name}, {self.first_name}'

class Language(models.Model):
    """
    Model representing book language
    """

    name = models.CharField(max_length=200, help_text='Enter a book language \
                            (e.g. English)'
                            )

    def __str__(self):
        """
        String representation pf the Model object
        :return: name
        """
        return self.name

catalog/forms.py
import datetime

from django import forms
from django.core.exceptions import ValidationError
from django.utils.translation import ugettext_lazy as _


class RenewBookForm(forms.Form):
    renewal_date = forms.DateField(help_text="Enter a date between now and 4 weeks (default 3).")

    def clean_renewal_date(self):
        data = self.cleaned_data['renewal_date']

        # Check if a date is not in the past. 
        if data < datetime.date.today():
            raise ValidationError(_('Invalid date - renewal in past'))

        # Check if a date is in the allowed range (+4 weeks from today).
        if data > datetime.date.today() + datetime.timedelta(weeks=4):
            raise ValidationError(_('Invalid date - renewal more than 4 weeks ahead'))

        # Remember to always return the cleaned data.
        return data

catalog/views.py
from django.shortcuts import render, get_object_or_404
from django.views import generic
from catalog.models import Book, Author, BookInstance, Genre, Language
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
import datetime
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.contrib.auth.decorators import permission_required

from catalog.forms import RenewBookForm

@login_required
def index(request):
    """
    View function for home page of the site
    """

    num_books = Book.objects.all().count()
    num_instances = BookInstance.objects.all().count()
    num_instance_available = BookInstance.objects.filter(status__exact='a').count()
    num_authors = Author.objects.all().count()
    num_visits = request.session.get('num_visits', 0)
    request.session['num_visits'] = num_visits + 1

    context = {
       'num_books' : num_books,
       'num_instances' : num_instances,
       'num_instance_available' :  num_instance_available,
       'num_authors' : num_authors,
        'num_visits' : num_visits,
    }
    return render(request, 'index.html', context = context)


class BookListView(LoginRequiredMixin, generic.ListView):
    model = Book
    paginate_by = 1


class BookDetailView(LoginRequiredMixin, generic.DetailView):
    model = Book


class LoanedBooksByUserListView(LoginRequiredMixin, generic.ListView):
    """Generic class-based view listing books on loan to current user."""
    model = BookInstance
    template_name = 'catalog/bookinstance_list_borrowed_user.html'
    paginate_by = 10

    def get_queryset(self):
        return BookInstance.objects.filter(borrower=self.request.user).filter(status__exact='o').order_by('due_back')


@permission_required('catalog.can_mark_returned')
def renew_book_librarian(request, pk):
    """View function for renewing a specific BookInstance by librarian."""
    book_instance = get_object_or_404(BookInstance, pk=pk)

    # If this is a POST request then process the Form data
    if request.method == 'POST':

        # Create a form instance and populate it with data from the request (binding):
        form = RenewBookForm(request.POST)

        # Check if the form is valid:
        if form.is_valid():
            # process the data in form.cleaned_data as required (here we just write it to the model due_back field)
            book_instance.due_back = form.cleaned_data['renewal_date']
            book_instance.save()

            # redirect to a new URL:
            return HttpResponseRedirect(reverse('all-borrowed') )

    # If this is a GET (or any other method) create the default form.
    else:
        proposed_renewal_date = datetime.date.today() + datetime.timedelta(weeks=3)
        form = RenewBookForm(initial={'renewal_date': proposed_renewal_date})

    context = {
        'form': form,
        'book_instance': book_instance,
    }

    return render(request, 'catalog/book_renew_librarian.html', context)

catalog/templates/base_generic.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    {% block title %} <title>Local Library </title> {% endblock %}
    <meta name = "viewport" content="width=device=width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
     {% load static %}
    <link rel="stylesheet" href="{% static 'css/styles.css' %}">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-2">
                {% block sidebar %}
                    <ul class="sidebar-nav">
                    <li><a href="{% url 'index' %}">Home</a> </li>
                    <li><a href="{% url 'books' %}">All Books</a> </li>
                    <li><a href="#">All Authors</a> </li>
                    </ul>
                    <ul class="sidebar-nav">

                         ...

                   {% if user.is_authenticated %}
                     <li>User: {{ user.get_username }}</li>

                        <li><a href="{% url 'my-borrowed' %}">My Borrowed</a></li>

                     <li><a href="{% url 'logout'%}?next={{request.path}}">Logout</a></li>
                   {% else %}
                     <li><a href="{% url 'login'%}?next={{request.path}}">Login</a></li>
                   {% endif %}
                  </ul>
                {% endblock %}
            </div>
        <div class="col-sm-10">{%  block content %} {% endblock %}
        {% block pagination %}
            {% if is_paginated %}
                <div class="pagination">
                <span class="page-links">
                    {% if page_obj.has_previous %}
                        <a href = "{{ request.path }}?page={{ page_obj.previous_page_number }}">previous</a>
                        {% endif %}
                <span class="page-current">
                    Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}.
                </span>
                {% if page_obj.has_next %}
                    <a href="{{ request.path }}?page={{ page_obj.next_page_number }}">next</a>
                    {% endif %}
                </span>
                </div>
            {% endif %}
        {% endblock %}
        </div>
        </div>
    </div>
</body>
</html>

catalog/templates/catalog/book_detail.html
{% extends "base_generic.html" %}

{% block content %}

<h1>Title: {{ book.title }}</h1>
    <p><strong>Author: </strong> <a href="#"> {{ book.author }}</a> </p>
    <p><strong>ISBN: </strong> {{ book.isbn }}] </p>
    <p><strong>Language: </strong>  {{ book.language }} </p>
    <p><strong>Genre: </strong> {% for genre in book.genre.all %}
    {{ genre }}{% if not forloop.last %}, {% endif %} {% endfor %}</p>
    <div style="margin-left: 20px; margin-top: 20px">
    <h4>Copies</h4>
    {% for copy in book.bookinstance_set.all %}
    <hr>
    <p class="{% if copy.status == 'a' %}text-success {% elif copy.status == 'm' %}
        text-danger{% else %} text-warning{% endif %}">
        {{ copy.get_status_display }}
    </p>
        <p><strong>ID:</strong>{{ copy.id }}</p>
    {% endfor %}
    </div>
{% endblock %}

catalog/templates/catalog/book_list.html
{% extends "base_generic.html" %}

{% block content %}
    <h1>Book List</h1>
    {% if book_list  %}
        <ul>
        {% for book in book_list %}
        <li>
            <a href="{{ book.get_absolute_url }}">{{ book.title }}</a>
            {{ book.author }}
        </li>
        {% endfor %}
        </ul>
    {% else %}
    <p>There are no books in the library</p>
    {% endif %}
{% endblock %}

catalog/templates/catalog/book_renew_librarian.html
{% extends "base_generic.html" %}

{% block content %}
  <h1>Renew: {{ book_instance.book.title }}</h1>
  <p>Borrower: {{ book_instance.borrower }}</p>
  <p{% if book_instance.is_overdue %} class="text-danger"{% endif %}>Due date: {{ book_instance.due_back }}</p>

  <form action="" method="post">
    {% csrf_token %}
    <table>
    {{ form.as_table }}
    </table>
    <input type="submit" value="Submit">
  </form>
{% endblock %}

catalog/templates/catalog/bookinstance_list_borrowed_user.html
{% extends "base_generic.html" %}

{% block content %}
    <h1>Borrowed books</h1>

    {% if bookinstance_list %}
    <ul>

      {% for bookinst in bookinstance_list %} 
      <li class="{% if bookinst.is_overdue %}text-danger{% endif %}">
        <a href="{% url 'book-detail' bookinst.book.pk %}">{{bookinst.book.title}}</a> ({{ bookinst.due_back }})        
      </li>
      {% endfor %}
    </ul>

    {% else %}
      <p>There are no books borrowed.</p>
    {% endif %}       
{% endblock %}

catalog/templates/index.html
{% extends "base_generic.html" %}

{% block content %}
    <h1>Local Library Home</h1>
    <p>Welcome t Local Libraty, a website developed by <em>Saurabh Tewary</em>!</p>
    <h2>Dynamic Content</h2>
    <p>The library has following record counts: </p>
    <ul>
    <li><strong>Books: </strong> {{ num_books }}</li>
    <li><strong>Copies: </strong> {{ num_instances }}</li>
    <li><strong>Copies available for issue: </strong> {{ num_instance_available }}</li>
    <li><strong>Authors: </strong> {{ num_authors }}</li>
    <li><strong>You have visited us: </strong> {{ num_visits }} <strong> times </strong></li>
    </ul>
{% endblock %}